#!/usr/bin/env python
from os.path import normpath, basename, ismount
import subprocess

def escape_spaces(s):
    return s.replace(" ", '\ ')
# get the devices mounted in /media, and /home
other_devices = subprocess.Popen(["cat /proc/mounts | awk '{print $2}' | grep -E '(/home|/media)'"], shell=True, stdout=subprocess.PIPE,)
other_devices = list(other_devices.stdout)
devices = ['/'] + other_devices # add root to devices

print ("${voffset 4}")

for device in devices:
    device = device.replace("\\040", ' ') # in case if space was in the name
    device = device.rstrip().decode("utf-8")
    if (True or ismount(device)): #https://bugs.python.org/issue2466 ismount doesn't work for NTFS
        if 'boot' in device.lower(): # skip boot disks
            continue

        if (device == "/"): # name root
            devicename="Root"
        else:
            devicename = basename(normpath(device)).capitalize()
        # start calculation dec value (for the pie chart symbol)
        statb = subprocess.Popen("stat -f -c %b "+escape_spaces(device)+"", shell=True, stdout=subprocess.PIPE,)
        statb_value = statb.communicate()[0]
        statf = subprocess.Popen("stat -f -c %f "+escape_spaces(device)+"", shell=True, stdout=subprocess.PIPE,)
        statf_value = statf.communicate()[0]
        total = int(statb_value)
        used = total - int(statf_value)
        dec = int((((used * 100) / total) + 5) / 10)
        if dec > 9:
            icon = "0"
        elif dec < 1:
            icon = "A"
        else:
            icon = str(dec)
        # end calculation dec

        print ("${voffset -10}${color0}${font Pie charts for maps:size=15}"+icon+"${font}${color}${offset 9}${voffset -9}"+devicename+": ${font Ubuntu:style=Bold:size=8}${color1}${fs_free_perc "+device+"}%${color}${font}\n")
        print ("${voffset -10}${offset 29}F: ${font Ubuntu:style=Bold:size=8}${color2}${fs_free "+device+"}${color}${font} U: ${font Ubuntu:style=Bold:size=8}${color2}${fs_used "+device+"}${color}${font}\n")

print ("${voffset -10}")
